--- port.tcl.old	Sat Nov 29 19:00:30 2003
+++ port.tcl	Tue Jan  6 01:29:46 2004
@@ -277,26 +277,28 @@
                 set shortname [file tail $rfile]
                 set fd [open $rfile r]
             }
-            set entry [read $fd]
-            # kind of a corner case but I ran into it testing
-            if {[catch {close $fd} result]} {
-                puts "Port failed: $rfile may be corrupted"
-		exit 1
-            }
 
-            # look for a contents list
-            set ix [lsearch $entry contents]
-            if {$ix >= 0} {
-                set contents [lindex $entry [incr ix]]
-                set uninst_err 0
+            while {-1 < [gets $fd line]} {
+                set match [regexp {^contents \{(.*)\}$} $line dummy contents]
+                if {$match == 1} {
                 puts "Contents of $shortname"
                 foreach f $contents {
                     puts "\t[lindex $f 0]"
                 }
-            } else {
+                    break
+                }
+            }
+
+            if {$match == 0} {
                 puts "No contents list for $shortname"
 		exit 1
             }
+
+            # kind of a corner case but I ran into it testing
+            if {[catch {close $fd} result]} {
+                puts "Port failed: $rfile may be corrupted"
+                exit 1
+            }
         } else {
             puts "Contents listing failed - no registry entry"
 	    exit 1
